import java.awt.*;
import java.awt.image.*;
import java.sql.*;
import java.io.*;
import java.net.*;

import oracle.jdbc.driver.*;


public class StoreImage{
  	int currentImageWidth = -2;
   	int currentImageHeight = -2;
    Connection connection = null;

	public static void printUsageMessage()
	{
        System.out.println( "Usage: java StoreImage FileName ImageName UserName ConnectionString");
	}



    private int getMimeTypeId(String fileName)
    {
        String sql = null;
        int mid = -1;
        if (!fileName.equals(""))
        {
            if (((fileName.substring(fileName.length()-3,fileName.length())).toUpperCase()).equals("GIF"))
                sql = "SELECT MID FROM MIME_TYPE WHERE MIME_TYPE_NAME='IMAGE/GIF'";
            if (((fileName.substring(fileName.length()-3,fileName.length())).toUpperCase()).equals("JPG"))
                sql = "SELECT MID FROM MIME_TYPE WHERE MIME_TYPE_NAME='IMAGE/JPEG'";
            if (((fileName.substring(fileName.length()-4,fileName.length())).toUpperCase()).equals("JPEG"))
                sql = "SELECT MID FROM MIME_TYPE WHERE MIME_TYPE_NAME='IMAGE/JPEG'";
            if (sql==null)
            {
                System.out.println("Image type not recognized");
                mid = -1;
            }
            else
            {
                try {
                    	PreparedStatement sqlStatement = connection.prepareStatement(sql);
                		sqlStatement.clearParameters();
                	    ResultSet results = sqlStatement.executeQuery();
                	    if (results.next()) {
                	        mid = results.getInt(1);
                	    }
                	    else {
                	        System.out.println("Mime type not found in database.");
                	        mid = -1;
                	    }
                        results.close();
                        sqlStatement.close();
                }
                catch ( Exception e )
                {
                    System.out.println(e.getMessage());
                    mid = -1;
                }
            }
        }
        else {
            System.out.println("Empty file name");
        }
        return (mid);
    }

    public void setSizes(String fileName)
    {
       MediaTracker tracker;
       Button c = new Button();
       tracker = new MediaTracker(c);

       Image img = Toolkit.getDefaultToolkit().getImage(fileName);
       tracker.addImage(img, 0);
       try {
           tracker.waitForAll();
       } catch (InterruptedException e) {}

        System.out.println("Height = "+img.getHeight(c));
        currentImageHeight=img.getHeight(c);
        System.out.println("Width  = "+img.getWidth(c));
        currentImageWidth=img.getWidth(c);
    }

	public void StoreImage1 (String fileName, String imageName, String userName, String connectionString) {
	    int fileSize = -1;
	    int mid = -1;
		try {
			if ( fileName.length()==0 ) {
                printUsageMessage();
			    return;
			}
			if ( imageName.length()==0 ) {
			    printUsageMessage();
			    return;
			}
			if ( connectionString.length()==0 ) {
			    printUsageMessage();
			    return;
			}


			Driver driver = new OracleDriver();
			String dbURL = "jdbc:oracle:thin:"+connectionString;
			connection = DriverManager.getConnection(dbURL);

			System.out.println( "Connected to database");

            setSizes(fileName);

			File f = new File(fileName);
            fileSize = (int)f.length();

            mid = getMimeTypeId(fileName);

            if (mid==-1) { System.out.println("Mime Type not recognized. Exiting."); return; }
            if (fileSize==-1) { System.out.println("File not found. Exiting."); return; }

	        InputStream istream = new FileInputStream(fileName);

            String sql = "SELECT USID FROM USERS WHERE LOGIN_NAME='"+userName+"'";
			Statement sqlStatement1 = connection.createStatement();
            ResultSet results = sqlStatement1.executeQuery(sql);

            int userId=-1;
            if (results.next()) {
                userId = results.getInt(1);
            }
            results.close();
            sqlStatement1.close();

            sql = "INSERT INTO IMAGE ( IID, NAME, MIME_TYPE_MID, SIZE_Y, SIZE_X, DATA, DATA_SIZE, OWNER_UID) ";
			sql+= "VALUES ( SEQ_IM.nextval, ?, ?, ?, ?, ?, ?, ? )";

			PreparedStatement sqlStatement = connection.prepareStatement(sql);
			sqlStatement.clearParameters();

            sqlStatement.setString( 1, imageName );
			sqlStatement.setInt( 2, mid );
			sqlStatement.setInt( 3, currentImageHeight );
			sqlStatement.setInt( 4, currentImageWidth );
			sqlStatement.setBinaryStream( 5, istream , 3000000 );
   			sqlStatement.setInt( 6, fileSize );
   			sqlStatement.setInt( 7, userId );


			sqlStatement.executeUpdate();

			istream.close();

	        connection.close();
			System.out.println( "OK, image stored.");
			System.exit(0);
    	}
		catch (Exception e) {
		  System.out.println("Error while storing image. Database reports: "+e.getMessage()+" Image not stored");
		  e.printStackTrace();
		}
	}


	public static void main (String args[]) {
	    StoreImage si = new StoreImage();
		if (args!=null)
		if ( args.length  == 4 )
		{
			si.StoreImage1( args[0], args[1], args[2], args[3] );
		}
   	    else System.out.println( "Usage: java StoreImage FileName ImageName UserName ConnectionString");
	}
}
