REM
REM  This ORACLE7 command file was generated by Oracle Server Generator
REM  Version 5.5.10.0.0 on 02-MAR-99
REM
REM For application WISDOM version 1 database WISDOMDB
REM
REM PACKAGE
REM      WISDOM_EDUOBJECT
REM      WISDOM_PROP_FUNC

REM
REM     .
REM
PROMPT 
PROMPT Creating Package Specification WISDOM_PROP_FUNC
CREATE OR REPLACE PACKAGE WISDOM_PROP_FUNC IS
  --
  -- .
  FUNCTION G_GEN_PR0(
  i_search_name IN VARCHAR2 )
RETURN VARCHAR2;
  --
  -- .
  FUNCTION G_GEN_PR1(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER )
RETURN VARCHAR2;
  --
  -- .
  FUNCTION G_GEN_PR2(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER )
RETURN VARCHAR2;
  --
  -- .
  FUNCTION G_GEN_PR3(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER ,
  i_fid IN INTEGER )
RETURN VARCHAR2;
  --
  -- .
  FUNCTION G_IMG_PR0(
  i_search_name IN VARCHAR2 )
RETURN NUMBER;
  --
  -- .
  FUNCTION G_IMG_PR1(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER )
RETURN NUMBER;
  --
  -- .
  FUNCTION G_IMG_PR2(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER )
RETURN NUMBER;
  --
  -- .
  FUNCTION G_IMG_PR3(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER ,
  i_fid IN INTEGER )
RETURN NUMBER;
END WISDOM_PROP_FUNC;
/


REM
PROMPT 
PROMPT Creating Package Body WISDOM_PROP_FUNC
CREATE OR REPLACE PACKAGE BODY WISDOM_PROP_FUNC IS
  --
  -- .
  FUNCTION G_GPRID(
  i_search_name IN varchar2 )
  RETURN INTEGER IS
  vprid NUMBER;
  BEGIN
  BEGIN
  SELECT PRID INTO vprid FROM GENERAL_PROPERTY WHERE
  SEARCH_NAME = i_search_name;
  EXCEPTION WHEN NO_DATA_FOUND THEN
  vprid:=-1;
  END;
  RETURN vprid;
  END;
  --
  -- .
  FUNCTION G_GEN_PR0(
  i_search_name IN VARCHAR2 )
  RETURN VARCHAR2 IS
  vprid NUMBER; 
  vval VARCHAR2(128);
  BEGIN
     BEGIN
        vprid := g_gprid(i_search_name);
        IF vprid = -1 THEN
           RETURN NULL;
        END IF;
        SELECT DEF_VALUE
        INTO
           vval
        FROM
           GENERAL_PROPERTY
        WHERE
           PRID=vprid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     RETURN vval;
  END;
  --
  -- .
  FUNCTION G_GEN_PR1(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER )
  RETURN VARCHAR2 IS
  vval VARCHAR2(128); 
  vprid NUMBER;
  BEGIN
     vprid:=g_gprid(i_search_name);
     IF vprid = -1 THEN
        RETURN NULL;
     END IF;
     BEGIN
        SELECT VALUE
        INTO
           vval
        FROM
           USER_GENERAL_PROPERTY
        WHERE
           GEN_PROP_PRID=vprid AND USER_UID=i_uid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     IF vval IS NOT NULL THEN
        RETURN vval;
     END IF;
     BEGIN
        SELECT DEF_VALUE
        INTO
           vval
        FROM
           GENERAL_PROPERTY
        WHERE
           PRID= vprid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     RETURN vval;
  END;
  --
  -- .
  FUNCTION G_GEN_PR2(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER )
  RETURN VARCHAR2 IS
  vval VARCHAR2(128); 
  vprid NUMBER;
  BEGIN
     vprid:=g_gprid(i_search_name);
     IF vprid = -1 THEN
        RETURN NULL;
     END IF;
     BEGIN
        SELECT VALUE
        INTO
           vval
        FROM
           ELEMENT_GENERAL_PROPERTY
        WHERE
           GEN_PROP_PRID= vprid AND ELEMENT_ID = i_pid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     IF vval IS NOT NULL THEN
        RETURN vval;
     END IF;
     BEGIN
        SELECT VALUE
        INTO
           vval
        FROM
           USER_GENERAL_PROPERTY
        WHERE
           GEN_PROP_PRID=vprid AND USER_UID=i_uid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     IF vval IS NOT NULL THEN
        RETURN vval;
     END IF;
     BEGIN
        SELECT DEF_VALUE
        INTO
           vval
        FROM
           GENERAL_PROPERTY
        WHERE
           PRID= vprid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     RETURN vval;
  END;
  --
  -- .
  FUNCTION G_GEN_PR3(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER ,
  i_fid IN INTEGER )
  RETURN VARCHAR2 IS
  vval VARCHAR2(128); 
  vprid NUMBER; 
  vparent_foil NUMBER; 
  vfid NUMBER;
  BEGIN
      vprid := g_gprid(i_search_name);
      IF vprid = -1 THEN
          RETURN NULL;
      END IF;
      --
      vfid:=i_fid;
      LOOP
          BEGIN
              BEGIN
                  SELECT VALUE
                  INTO
                      vval
                  FROM
                      ELEMENT_GENERAL_PROPERTY
                  WHERE
                      GEN_PROP_PRID=vprid AND ELEMENT_ID=vfid;
              EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                  vval:=NULL;
              END;
              IF vval IS NOT NULL THEN
                  RETURN vval;
              END IF;
              BEGIN
                  SELECT SOURCE_ID
                  INTO
                      vparent_foil
                  FROM
                      COMPONENT
                  WHERE
                      ID=vfid;
              EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                  vparent_foil:=NULL;
              END;
              EXIT WHEN vparent_foil IS NULL;
              vfid:=vparent_foil;
          END;
      END LOOP;
      --
      BEGIN
          SELECT VALUE
          INTO
              vval
          FROM
              ELEMENT_GENERAL_PROPERTY
          WHERE
              GEN_PROP_PRID = vprid AND ELEMENT_ID = i_pid;
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
          vval:=NULL;
      END;
      IF vval IS NOT NULL THEN
          RETURN vval;
      END IF;
      --
      BEGIN
          SELECT VALUE
          INTO
              vval
          FROM
              USER_GENERAL_PROPERTY
          WHERE
              GEN_PROP_PRID = vprid AND USER_UID= i_uid;
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
          vval:=NULL;
      END;
      IF vval IS NOT NULL THEN
          RETURN vval;
      END IF;
      --
      BEGIN
          SELECT DEF_VALUE
          INTO
              vval
          FROM
              GENERAL_PROPERTY
          WHERE
              PRID= vprid;
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
          vval:=NULL;
      END;
      RETURN vval;
  END;
  --
  -- .
  FUNCTION G_IPRID(
  i_search_name IN varchar2 )
  RETURN INTEGER IS
  vprid NUMBER;
  BEGIN
     BEGIN
        SELECT PRID
        INTO
           vprid
        FROM
           IMAGE_PROPERTY
        WHERE
           SEARCH_NAME = i_search_name;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vprid:=-1;
     END;
     RETURN vprid;
  END;
  --
  -- .
  FUNCTION G_IMG_PR0(
  i_search_name IN VARCHAR2 )
  RETURN NUMBER IS
  vprid NUMBER; 
  vval NUMBER;
  BEGIN
     BEGIN
        vprid := g_iprid(i_search_name);
        IF vprid = -1 THEN
        RETURN NULL;
        END IF;
        
        SELECT DEF_VALUE_IID
        INTO
           vval
        FROM
           IMAGE_PROPERTY
        WHERE
           PRID=vprid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     RETURN vval;
  END;
  --
  -- .
  FUNCTION G_IMG_PR1(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER )
  RETURN NUMBER IS
  vval NUMBER; 
  vprid NUMBER;
  BEGIN
     vprid:=g_iprid(i_search_name);
     BEGIN
        SELECT VALUE_IID
        INTO
           vval
        FROM
           USER_IMAGE_PROPERTY
        WHERE
           IMAGE_PROP_PRID=vprid AND USER_UID=i_uid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     IF vval IS NOT NULL THEN
        RETURN vval;
     END IF;
     
     BEGIN
        SELECT DEF_VALUE_IID
        INTO
           vval
        FROM
           IMAGE_PROPERTY
        WHERE
           PRID= vprid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     RETURN vval;
  END;
  --
  -- .
  FUNCTION G_IMG_PR2(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER )
  RETURN NUMBER IS
  vval NUMBER; 
  vprid NUMBER;
  BEGIN
     vprid:=g_iprid(i_search_name);
     IF vprid = -1 THEN
        RETURN NULL;
     END IF;
     BEGIN
        SELECT VALUE_IID
        INTO
           vval
        FROM
           ELEMENT_IMAGE_PROPERTY
        WHERE
           IMAGE_PROP_PRID= vprid AND ELEMENT_ID = i_pid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     IF vval IS NOT NULL THEN
        RETURN vval;
     END IF;
     BEGIN
        SELECT VALUE_IID
        INTO
           vval
        FROM
           USER_IMAGE_PROPERTY
        WHERE
           IMAGE_PROP_PRID=vprid AND USER_UID=i_uid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     IF vval IS NOT NULL THEN
        RETURN vval;
     END IF;
     BEGIN
        SELECT DEF_VALUE_IID
        INTO
           vval
        FROM
           IMAGE_PROPERTY
        WHERE
           PRID= vprid;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
        vval:=NULL;
     END;
     RETURN vval;
  END;
  --
  -- .
  FUNCTION G_IMG_PR3(
  i_search_name IN VARCHAR2 ,
  i_uid IN INTEGER ,
  i_pid IN INTEGER ,
  i_fid IN INTEGER )
  RETURN NUMBER IS
  vval NUMBER; 
  vprid NUMBER;
  vparent_foil NUMBER;
  vfid NUMBER;
  BEGIN
      vprid := g_iprid(i_search_name);
      IF vprid = -1 THEN
          RETURN NULL;
      END IF;
      --
      
      vfid:=i_fid;
      LOOP
         BEGIN
             BEGIN
                 SELECT VALUE_IID
     
   	        INTO
  	            vval
  	        FROM
  	            ELEMENT_IMAGE_PROPERTY
  	        WHERE
  	            IMAGE_PROP_PRID = vprid AND ELEMENT_ID = vfid; 
              EXCEPTION
  	        WHEN NO_DATA_FOUND THEN
  	        vval:=NULL;
              END;
              IF vval IS NOT NULL THEN
                   RETURN vval;
              END IF;
              BEGIN
               SELECT SOURCE_ID
              INTO
                 vparent_foil
              FROM
                 COMPONENT
              WHERE
                 ID=vfid;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
              vparent_foil:=NULL;
           END;
           EXIT WHEN vparent_foil IS NULL;
           vfid:=vparent_foil; 
        END;
     END LOOP;             
      
      --
      BEGIN
          SELECT VALUE_IID
          INTO
              vval
          FROM
              ELEMENT_IMAGE_PROPERTY
          WHERE
              IMAGE_PROP_PRID = vprid AND ELEMENT_ID = i_pid;
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
          vval:=NULL;
      END;
      IF vval IS NOT NULL THEN
          RETURN vval;
      END IF;
      --
      BEGIN
          SELECT VALUE_IID
          INTO
              vval
          FROM
              USER_IMAGE_PROPERTY
          WHERE
              IMAGE_PROP_PRID = vprid AND USER_UID= i_uid;
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
          vval:=NULL;
      END;
      IF vval IS NOT NULL THEN
          RETURN vval;
      END IF;
      --
      BEGIN
          SELECT DEF_VALUE_IID
          INTO
              vval
          FROM
              IMAGE_PROPERTY
          WHERE
              PRID= vprid;
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
          vval:=NULL;
      END;
      RETURN vval;
  END;
END WISDOM_PROP_FUNC;
/

REM
REM     GETS SOME INFORMATION ABOUT EDUOBJECT FOR A FOIL
REM
PROMPT 
PROMPT Creating Package Specification WISDOM_EDUOBJECT
CREATE OR REPLACE PACKAGE WISDOM_EDUOBJECT IS
  --
  -- GETS COUNT OF EDUOBJECT ASSOCIATED WITH A GIVEN FOIL OR SHADOW
  FUNCTION GET_EID_COUNT(
  i_fid  INTEGER ,
  i_etid  INTEGER )
RETURN INTEGER;
  --
  -- GETS EDU OBJECT ID FOR GIVEN FOIL, TYPE, AND POSITION
  FUNCTION GET_EID(
  i_fid  INTEGER ,
  i_etid  INTEGER ,
  i_position  INTEGER ,
  i_resolution  varchar2 )
RETURN INTEGER;
  --
  -- .
  FUNCTION GET_RID(
  i_resname  VARCHAR2 )
RETURN INTEGER;
END WISDOM_EDUOBJECT;
/


REM
PROMPT 
PROMPT Creating Package Body WISDOM_EDUOBJECT
CREATE OR REPLACE PACKAGE BODY WISDOM_EDUOBJECT IS
  --
  -- GETS COUNT OF EDUOBJECT ASSOCIATED WITH A GIVEN FOIL OR SHADOW
  FUNCTION GET_EID_COUNT(
  i_fid  INTEGER ,
  i_etid  INTEGER )
  RETURN INTEGER IS
  vfid NUMBER; 
  vparent_foil NUMBER; 
  vcount NUMBER;
  BEGIN
     vfid:=i_fid;
     LOOP
        BEGIN
           BEGIN
              SELECT COUNT(*)
              INTO
                 vcount
              FROM
                 COMP_EDU
              WHERE
                 comp_id = vfid AND EDU_TYPE_ETID=i_etid;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
              vcount:=NULL;
           END;
           IF vcount IS NOT NULL AND vcount<>0 THEN
              RETURN vcount;
           END IF;
           BEGIN
              SELECT SOURCE_ID
              INTO
                 vparent_foil
              FROM
                 COMPONENT
              WHERE
                 ID=vfid;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
              vparent_foil:=NULL;
           END;
           EXIT WHEN vparent_foil IS NULL;
           vfid:=vparent_foil;
        END;
     END LOOP;
     RETURN 0;
  END;
  --
  -- GETS EDU OBJECT ID FOR GIVEN FOIL, TYPE, AND POSITION
  FUNCTION GET_EID(
  i_fid  INTEGER ,
  i_etid  INTEGER ,
  i_position  INTEGER ,
  i_resolution  varchar2 )
  RETURN INTEGER IS
  vfid NUMBER; 
  vparent_foil NUMBER; 
  veid NUMBER; 
  vcount NUMBER; 
  vrid NUMBER; 
  vrid_t NUMBER;
  BEGIN
     vfid:=i_fid;
     IF(UPPER(i_resolution) = 'MINIMAL') THEN
        vrid:=0;
     ELSIF
        (UPPER(i_resolution) = 'NONE') THEN
        vrid:=-1;
     ELSE
        vrid:=get_rid(i_resolution);
     END IF;
     LOOP
        BEGIN
           BEGIN
              IF vrid=-1 THEN
                 SELECT edu_eid
                 INTO
                    veid
                 FROM
                    COMP_EDU
                 WHERE
                    comp_id = vfid 
                    AND EDU_TYPE_ETID=i_etid 
                    AND position=i_position AND resolution_rid IS NULL;
              ELSIF
                 vrid=0 THEN
                 BEGIN
                    SELECT MIN(resolution_rid)
                    INTO
                       vrid_t
                    FROM
                       COMP_EDU
                    WHERE
                       comp_id=vfid AND 
                       edu_type_etid=i_etid AND position=i_position;
                    IF vrid_t IS NOT NULL AND vrid_t>0 THEN
                       SELECT edu_eid
                       INTO
                          veid
                       FROM
                          COMP_EDU
                       WHERE
                          comp_id = vfid 
                          AND EDU_TYPE_ETID=i_etid 
                          AND position=i_position AND resolution_rid=vrid_t;
                    ELSE
                       veid:=NULL;
                    END IF;
                 END;
              ELSE         
                  BEGIN
                    SELECT MIN(resolution_rid)
                    INTO
                       vrid_t
                    FROM
                       COMP_EDU
                    WHERE
                       comp_id=vfid AND 
                       edu_type_etid=i_etid AND position=i_position AND 
                       resolution_rid>=vrid;
                    IF vrid_t IS NULL OR vrid_t<=0 THEN
                    SELECT MAX(resolution_rid)
                    INTO 
                       vrid_t
                    FROM 
                       COMP_EDU
                     WHERE
                       comp_id=vfid AND
                       edu_type_etid=i_etid AND position=i_position AND 
                       resolution_rid<=vrid;
                    END IF;
                    IF vrid_t IS NOT NULL AND vrid_t>0 THEN
                       SELECT edu_eid
                       INTO
                          veid
                       FROM
                          COMP_EDU
                       WHERE
                          comp_id = vfid 
                          AND EDU_TYPE_ETID=i_etid 
                          AND position=i_position AND resolution_rid=vrid_t;
                    ELSE
                       veid:=NULL;
                    END IF;
                 END;
              END IF;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
              veid:=NULL;
           END;
           IF veid IS NOT NULL THEN
              RETURN veid;
           END IF;
           BEGIN
              SELECT COUNT(*)
              INTO
                 vcount
              FROM
                 comp_EDU
              WHERE
                 comp_id = vfid AND edu_type_etid=i_etid;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
              vcount:=NULL;
           END;
           IF vcount IS NOT NULL AND vcount<>0 THEN
              RETURN NULL;
           END IF;
           BEGIN
              SELECT SOURCE_ID
              INTO
                 vparent_foil
              FROM
                 COMPONENT
              WHERE
                 ID=vfid;
           EXCEPTION
              WHEN NO_DATA_FOUND THEN
              vparent_foil:=NULL;
           END;
           EXIT WHEN vparent_foil IS NULL;
           vfid:=vparent_foil;
        END;
     END LOOP;
     RETURN NULL;
  END;
  --
  -- .
  FUNCTION GET_RID(
  i_resname  VARCHAR2 )
  RETURN INTEGER IS
  vrid NUMBER;
  BEGIN
     SELECT rid INTO vrid FROM
     RESOLUTION WHERE
     res_name=i_resname;
     RETURN vrid;
     END;
END WISDOM_EDUOBJECT;
/
