import java.io.*;
import java.util.*;
import java.sql.*;
import java.sql.Date;
import db.*;
import view.*;

public class Tags extends TDLTag {

//General login
    public String WW_DEFAULTBG () {
        String irs = getImageString ("mainBGImage_WNT");
        return irs;
    }
    public String WW_DEFAULTLOGO () {
        String irs = getImageString ("WNTLogo_WNT");
        return irs;
    }
    
    public String WW_LOGINFORM () {
        String formTag = "<FORM ACTION=\"/"+getStringAttrValue(Constants.ServletDirProperty)+"/"+getStringAttrValue(Constants.ServletNameProperty)+"/"+getStringAttrValue(Constants.TemplateIDProperty)+"\" METHOD=POST>";
        formTag += "<INPUT TYPE=\"HIDDEN\" NAME=\"template\" VALUE=\""+getStringAttrValue(Constants.TemplateIDProperty)+"\">";
        formTag += "<INPUT TYPE=\"HIDDEN\" NAME=\"todo\" VALUE=\"login\">";
        String slashFormTag = "<INPUT TYPE=\"Submit\" NAME=\"Submit\" VALUE=\"Login\"> <INPUT TYPE=\"Reset\" NAME=\"Reset\" VALUE=\"Clear\"></FORM>";
        return formTag + parseChildren() + slashFormTag;
    }

    public String WW_USERNAME () {
        return "<INPUT TYPE=\"TEXT\" NAME=\"user\" SIZE=\"20\">";
    }

    public String WW_PASSWORD () {
        return "<INPUT TYPE=\"PASSWORD\" NAME=\"pass\" SIZE=\"20\">";
    }


//FOR NPAC TEMPLATES
    public String WW_NOTE (String foilID, String parentID) {
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);
        
        MediaObject mo = dbUtil.getPrimaryMediaObject (getConn(), string2Int (foilID), string2Int (parentID), Constants.DatabaseNoteEduType, 1);
        
        String text = new String (mo.data);
        String newText = processPTagTable (text);
        return newText;
    }

    public String WW_EXTERNALURL (String foilID, String parentID) {
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);
        
        MediaObject mo = dbUtil.getPrimaryMediaObject (getConn(), string2Int (foilID), string2Int (parentID), Constants.DatabaseExternalEduType, 1);
        
        String text = new String (mo.data);
        return "<A HREF=\""+text+"\"> External URL </A>";
    }
    
    
    public String WW_SELECTIMAGE (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseImageEduType)) res += parseChildren();       
        return res;
    }
    
    public String WW_SELECTTEXT (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseTextEduType)) res += parseChildren();       
        return res;
    }
    
    public String WW_SELECTNOTE (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseNoteEduType)) res += parseChildren();       
        return res;
    }

 
    public String WW_SELECTCOMMENT (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseCommentEduType)) res += parseChildren();       
        return res;
    }

    
    public String WW_SELECTEXTERNAL (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseExternalEduType)) res += parseChildren();       
        return res;
    }

 
    public String WW_SELECTSOURCEPRES (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseSPresEduType)) res += parseChildren();       
        return res;
    }

    public String WW_SELECTSOURCEFOIL (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseSFoilEduType)) res += parseChildren();       
        return res;
    }
 
    public String WW_SELECTSOURCEMASTER (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseSMasterEduType)) res += parseChildren();       
        return res;
    }

/**
  * Inserts foil position into variable
  *
  * @param parentID - presentation id
  * @param foilID - current foil id
  * @param name - name of the variable
  *
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_SETPOSITION (String parentID, String foilID, String name) {
        parentID = evaluateExpression(parentID);
        foilID = evaluateExpression(foilID);
        name = evaluateExpression(name);
        String p = getFoilPosition (foilID, parentID);
        setStringAttrValue(name, p);
     	return "";
    }
    



/**
  * Inserts annotation for foil.
  *
  * @param presentationID - id of the presentation
  *
  * @return String with annotation for the foil
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ANNOTATION (String presentationID, String position) {
        presentationID = evaluateExpression(presentationID);
        position = evaluateExpression(position);

        return calculateAnnotation (presentationID, position);
    }


/**
  * Inserts name of the foilworld
  *
  * @param fwID - id of the foilworld
  *
  * @return String with foilworld name
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_TITLEFOILWORLD (String fwID) {
        fwID = evaluateExpression(fwID);
        String res = "";

        String query = "SELECT NAME FROM FOILWORLD WHERE WID="+fwID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) 
           		res = rs.getString("NAME");
            rs.close(); 
            sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_TITLEFOILWORLD.SQLException");
        }
       	return res;
    }

/**
  * Inserts into <code>name</code> variable id of the first foil
  * from the presentation given by <code>parentID</code>.
  *
  * @param parentID - id of the presentation
  * @param name - name of the variable
  *
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FIRSTFOIL (String parentID, String name) {
        parentID = evaluateExpression(parentID);
        name = evaluateExpression(name);
        setIntAttrValue (name, getFoilPid(1, string2Int(parentID)));
        return "";
    }
    
/**
  * Executes contents only if there is no image for foil.
  *
  * @param foilID - id of the foil
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_NOBULLETSIFGIF (String foilID) {
        foilID = evaluateExpression(foilID);

        int number=0;
        String query = "SELECT COUNT(*) FROM PRES_EDU WHERE PRES_PID = "+foilID+" AND EDU_TYPE_ETID = (SELECT ETID FROM EDU_TYPE WHERE TYPE_NAME = '"+Constants.DatabaseImageEduType+"')";

        try {
       		Statement sqlStatement = getConn().createStatement();
        	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                number = rs.getInt(1);
            }
            rs.close(); 
            sqlStatement.close();
            
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_NOBULLETSIFGIF");
        }
        if (number == 0) 
            return parseChildren();
        else 
            return "";
    }
    
/**
  * Inserts BODY tag for templates with images
  * <b>To be implemented properly</b>
  *
  * @return BODY tag
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_BODYIMAGE (String foilID, String parentID) {
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);
        int u = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        String userID = new Integer(u).toString();
        int f = string2Int (foilID);
        int p = string2Int (parentID);
        
        String irs = getImageRetrievalString ("body_background_image", foilID, parentID, userID);
        String txtProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_text", f, p, u));
        String bgcolorProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_bgcolor", f, p, u));
        String linkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_link_image", f, p, u));
        String vlinkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_vlink_image", f, p, u));
        String alinkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_alink_image", f, p, u));

        return ("<body  background=\""+irs+"\" bgcolor=\""+bgcolorProp+"\" link=\""+linkProp+"\" vlink=\""+vlinkProp+"\" alink=\""+alinkProp+"\" text=\""+txtProp+"\">");
    }

/**
  * Inserts BODY tag for index templates 
  * <b>To be implemented properly</b>
  *
  * @return BODY tag
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_BODYINDEX (String presentationID) {
        presentationID = evaluateExpression(presentationID);
        int u = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        String userID = new Integer(u).toString();
        
        int p = string2Int (presentationID);
        
        String irs = getImageRetrievalString ("body_background_image", presentationID, presentationID, userID);
        String txtProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_text", p, u));
        String bgcolorProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_bgcolor", p, u));
        String linkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_link", p, u));
        String vlinkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_vlink", p, u));
        String alinkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_alink", p, u));

        return ("<body  background=\""+irs+"\" bgcolor=\""+bgcolorProp+"\" link=\""+linkProp+"\" vlink=\""+vlinkProp+"\" alink=\""+alinkProp+"\" text=\""+txtProp+"\">");
    }

/**
  * Inserts IMG tag to image taken from the database.
  *
  * @param imageName - name of the image (property name)
  * @param foilID - id of the foil
  * @param parentID - id of the presentation
  *
  * @return IMG tag
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_IMAGE (String imageName, String foilID, String parentID) {
        imageName = evaluateExpression (imageName);
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);
        int usid = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        String userID = new Integer(usid).toString();
        
        String irs = getImageRetrievalString (imageName, foilID, parentID, userID);
        return ("<IMG SRC=\""+irs+"\" BORDER=0>");
    }
    
/**
  * Inserts HREF link to the template with full image
  *
  * @param foilID - id of the foil
  * @param parentID - id of the presentation
  *
  * @return HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_MISSING (String foilID, String parentID) {
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);

    	return ("<A HREF=\"tempfoilsepimage.tdl?FID="+foilID+"&PID="+parentID+"\">See also color IMAGE</A>");
    }

/**
  * Inserts HREF link to the full image of the presentation abstract
  *
  * @param presentationID - id of the presentation
  *
  * @return HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ABSMISSING (String presentationID) {
        presentationID = evaluateExpression(presentationID);

        int pid = -1;
        String query = "SELECT ABSTRACT_PID FROM PRESENTATION WHERE PID="+presentationID;        
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                pid = rs.getInt("ABSTRACT_PID");
                if (rs.wasNull()) pid = getSecondPid(presentationID);
            } 
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
                ExceptionHandler.handleException(e,"WW_ABSTRACTIMAGE.SQLException");
        }
        if (pid != -1)
        	return ("<A HREF=\"tempfoilsepimage.tdl?FID="+pid+"&PID="+presentationID+"\">See also color IMAGE</A>");
        else
            return "";
    }

/**
  * Inserts BODY tag for templates with HTML
  * <b>To be implemented properly</b>
  *
  * @return BODY tag
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_BODYSEPHTML (String foilID, String parentID) {
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);
        int u = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        String userID = new Integer(u).toString();
        int f = string2Int (foilID);
        int p = string2Int (parentID);
        
        String irs = getImageRetrievalString ("body_background_html", foilID, parentID, userID);
        String txtProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_text", f, p, u));
        String bgcolorProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_bgcolor", f, p, u));
        String linkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_link_table", f, p, u));
        String vlinkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_vlink_table", f, p, u));
        String alinkProp = dbPropertyReader.getColor(getConn(),dbPropertyReader.getColorProperty(getConn(),"body_alink_table", f, p, u));

        return ("<body  background=\""+irs+"\" bgcolor=\""+bgcolorProp+"\" link=\""+linkProp+"\" vlink=\""+vlinkProp+"\" alink=\""+alinkProp+"\" text=\""+txtProp+"\">");
    }


/**
  * Inserts first event for the foil.
  *
  * @param foilID - id of the foil
  *
  * @return String with event name and place
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_EVENT (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";

        String query = "SELECT E.NAME, E.PLACE FROM EVENT E, PRES_EVENT P WHERE E.EVID=P.EVENT_EVID AND P.PRES_PID="+foilID+" ORDER BY P.POSITION";
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) 
           		res = rs.getString("NAME")+", "+rs.getString("PLACE");
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_EVENT.SQLException");
        }
       	return res;
    }
    
/**
  * Inserts first event date for the foil.
  *
  * @param foilID - id of the foil
  *
  * @return String with event date
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_EVENTDATE (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";

        String query = "SELECT E.BEG_DATE, E.END_DATE FROM EVENT E, PRES_EVENT P WHERE E.EVID=P.EVENT_EVID AND P.PRES_PID="+foilID+" ORDER BY P.POSITION";
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                String edate = "";
                Date ed = rs.getDate("END_DATE");
                if (!rs.wasNull()) edate = " to "+ed.toString();
       		    Date dt = rs.getDate("BEG_DATE");
           		res = dt.toString()+edate;
           	}
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_EVENTDATE.SQLException");
        }
       	return res;
    }

        
/*LOOPS*/
/**
  * Main tag for all TDL documents
  * Standard TDL tag implementation.
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_DOCUMENT () {
        return parseChildren();
    }

/**
  * FOR loop.
  * Standard TDL tag implementation.
  *
  * @param name - name of the loop variable
  * @param from - starting value
  * @param to - ending value
  * @param step - incrementation step
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOR(String name, String from, String to, String step) {
        name = evaluateExpression(name);
        from = evaluateExpression(from);
        to = evaluateExpression(to); 
        step = evaluateExpression(step);
        
        String res = "";
        float ifrom = (new Float(from)).floatValue();
        float ito = (new Float(to)).floatValue();
        float istep = (new Float(step)).floatValue();

        for (float i = ifrom; i<=ito; i = i + istep) {
            setFloatAttrValue(name,i);
            res += parseChildren();
        }
        return res;
    }
    
/**
  * ITERATION loop.
  * Standard TDL tag implementation.
  *
  * @param name - name of the loop variable
  * @param list - list of elements separated by ","
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ITERATION (String name, String list) {
        name = evaluateExpression(name);
        String res = "";
        StringTokenizer st = new StringTokenizer (list, Constants.IterationListDelimiter);
        while (st.hasMoreElements()) {
            setStringAttrValue(name, evaluateExpression((String)st.nextElement()));
            res+=parseChildren();
        }
        return res;
    }

/**
  * WHILE loop.
  * Standard TDL tag implementation.
  * <b> Use with caution, possible infinite loops</b>.
  *
  * @param condition - loop condition, loop ends when <code>false</code>
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_WHILE (String condition) {
        String firstCondition = evaluateExpression(condition);
        String res="";        
        while (firstCondition != "") {
            res+=parseChildren();
            firstCondition = evaluateExpression(condition);
        }
        return res;
    }
    
/**
  * QUERY loop.
  * Standard TDL tag implementation.
  *
  * @param names - list of names separated by "," in which query results are stored
  * @param sql - SQL query
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_QUERY (String names, String sql) {
        sql = evaluateExpression(sql);
        String res = "";
        Statement sqlStatement;
        StringTokenizer st = new StringTokenizer(names,Constants.NamesListDelimiter);
        try {
    		sqlStatement = getConn().createStatement();
	    	ResultSet rs = sqlStatement.executeQuery(sql);
            while (rs.next()) {
                int ii=0;
                while (st.hasMoreTokens()) {
                    setStringAttrValue(evaluateExpression((String)st.nextElement()),rs.getObject(ii++).toString());
                }
                res+=parseChildren();
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_QUERY.SQLException");
        }
        return res;
    }

/*CONDITIONAL*/
/**
  * IF loop.
  * Standard TDL tag implementation.
  * <b>Must be used with THEN and/or ELSE tags</b>.
  *
  * @param condition - <code>if</code> condition
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_IF (String condition) {
        String res="";
        condition = evaluateExpression(condition);
        setIntAttrValue(Constants.IFLevelProperty,getIntAttrValue(Constants.IFLevelProperty)+1);
        if (condition!="") 
            setIntAttrValue(Constants.IFLevelConditionProperty+getIntAttrValue(Constants.IFLevelProperty),1);
        else 
            setIntAttrValue(Constants.IFLevelConditionProperty+getIntAttrValue(Constants.IFLevelProperty),0);
        res+=parseChildren();
        removeAttrValue(Constants.IFLevelConditionProperty+getIntAttrValue(Constants.IFLevelProperty));
        setIntAttrValue(Constants.IFLevelProperty,getIntAttrValue(Constants.IFLevelProperty)-1);
        return res;
    }
    
/**
  * THEN loop.
  * Standard TDL tag implementation.
  * <b>Have to be used only in IF tag context</b>.
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_THEN () {
        if (getIntAttrValue(Constants.IFLevelConditionProperty+getIntAttrValue(Constants.IFLevelProperty))==1)
            return parseChildren();
        else
            return "";
    }

/**
  * ELSE loop.
  * Standard TDL tag implementation.
  * <b>Have to be used only in IF tag context</b>.
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ELSE () {
        if (getIntAttrValue(Constants.IFLevelConditionProperty+getIntAttrValue(Constants.IFLevelProperty))==0)
            return parseChildren();
        else
            return "";
    }

/*VARIABLES*/
/**
  * Inserts result of the calculation or the variable value.
  * Standard TDL tag implementation.
  *
  * @param name - variable or expression
  *
  * @return String with a value
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_INSERT(String name) {
        return evaluateExpression(name);
    }
    
/**
  * Inserts result of the calculation or the variable value 
  * into <code>name</code> variable.
  * Standard TDL tag implementation.
  *
  * @param name - name of the variable
  * @param value - variable or expression value
  *
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_SET (String name, String value) {
        name = evaluateExpression(name);
        value = evaluateExpression(value);
        setStringAttrValue (name,value);
        return "";
    }
/*DATABASE*/
/**
  * Connects to database.
  * Standard TDL tag implementation.
  *
  * @param connection - connection string, if <code>connection</code> is empty,
  * default value is taken from property file.
  *
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_CONNECT (String connection) {
        connection = evaluateExpression(connection);
        if (connection.equals("")) {
            connection = getStringAttrValue (Constants.ConnectionStringProperty);
        }
        else {
            setStringAttrValue (Constants.ConnectionStringProperty,connection);
        }
        try {
            setConn (DriverManager.getConnection(connection));
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_CONNECT");
        }
        return "";
    }
    
/**
  * Process the contents inserting into the <code>name</code> variable foilworld id's
  * in the foilworld specified by <code>fwid<code>
  *
  * @param fwID - foilworld id
  * @param name - name of the variable
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILWORLDLOOP (String fwID, String name) {
        name = evaluateExpression(name);
        fwID = evaluateExpression(fwID);

        int usid = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        
        String res = "";
        
        
        String query = "SELECT WID FROM FOILWORLD WHERE BUFFER_OWNER_UID IS NULL AND WID<>1 AND BELONGS_TO_WID = "+fwID+" ORDER BY NAME";
        try {
       		Statement sqlStatement = getConn().createStatement();
        	ResultSet rs = sqlStatement.executeQuery(query);
            while (rs.next()) {
                int wid = rs.getInt("WID");
                if (userHasRights(wid, usid)) { 
                    setStringAttrValue(name, int2String(wid));
                    res+=parseChildren();
                }
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_FOILWORLDLOOP");
        }
        return res;
    }
    
/**
  * Process the contents inserting into the <code>name</code> variable presentation id's
  * in the foilworld specified by <code>fwid<code>
  *
  * @param fwID - foilworld id
  * @param name - name of the variable
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_PRESENTATIONLOOP (String fwID, String name) {
        name = evaluateExpression(name);
        fwID = evaluateExpression(fwID);
        
        String res = "";
        String query = "SELECT COMPONENT_PID FROM FW_CONTAIN_PR WHERE CONTAINER_WID="+fwID;
        try {
       		Statement sqlStatement = getConn().createStatement();
        	ResultSet rs = sqlStatement.executeQuery(query);
            while (rs.next()) {
                setStringAttrValue(name,rs.getString("COMPONENT_PID"));
                res+=parseChildren();
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_PRESENTATIONLOOP");
        }
        return res;
    }


/**
  * Process the contents inserting into the <code>name</code> variable foil id's
  * in the presentation specified by <code>parentID<code>
  *
  * @param parentID - presentation id
  * @param name - name of the variable
  *
  * @return Parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILLOOP (String parentID, String name) {
        name = evaluateExpression(name);
        parentID = evaluateExpression(parentID);
        String res="";
        
        Vector vc = new Vector();
        fillFoilID(parentID, vc);
        Enumeration en = vc.elements();
        while (en.hasMoreElements()) {
                setStringAttrValue(name,(String)en.nextElement());
                res+=parseChildren();
        }
        return res;        
    }

    
    public String WW_FWPARENTLINK (String fwID, String fileName, String attr) {
        fwID = evaluateExpression(fwID);
        fileName = evaluateExpression(fileName);
        attr = evaluateExpression(attr);
        
        if (fwID.equals("1")) return "";

        int fid = dbCore.getNumber_(getConn(),"SELECT BELONGS_TO_WID FROM FOILWORLD WHERE WID = "+fwID);
        return ("<A HREF=\""+fileName+"?FWID="+fid+"&"+attr+"\">(..) Parent Foilworld</A><P>");
    }
/**
  * Inserts HREF link to foilworld. Link points to <code>filename</code> with optional 
  * attributes and with fwID parameter appended.
  *
  * @param fwID - foilworld id
  * @param fileName - name of the file
  * @param attr - extra attributes
  *
  * @return HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILWORLDLINK (String fwID, String fileName, String attr) {
        fwID = evaluateExpression(fwID);
        fileName = evaluateExpression(fileName);
        attr = evaluateExpression(attr);
        String res = "";

        String query = "SELECT NAME, WID FROM FOILWORLD WHERE WID="+fwID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                res = "<A HREF=\""+fileName+"?FWID="+rs.getInt("WID")+"&"+attr+"\">"+rs.getString("NAME")+"</A><P>";
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_FOILWORLDLINK");
        }
        return res;
    }

/**
  * Inserts HREF link to presentation. Link points to <code>filename</code> with optional 
  * attributes and with PID parameter appended.
  *
  * @param presentationID - presentation id
  * @param fileName - name of the file
  * @param attr - extra attributes
  *
  * @return HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_PRESENTATIONLINK (String presentationID, String fileName, String attr) {
        presentationID = evaluateExpression(presentationID);
        fileName = evaluateExpression(fileName);
        attr = evaluateExpression(attr);
        String res = "";

        String query = "SELECT TITLE, PID FROM PRESENTATION WHERE PID="+presentationID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                res = "<A HREF=\""+fileName+"?PID="+rs.getInt("PID")+"&"+attr+"\">"+rs.getString("TITLE")+"</A><P>";
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_PRESENTATIONLINK");
        }
        return res;
    }

/**
  * Inserts HREF link to foil. Link points to <code>filename</code> with optional 
  * attributes and with FID parameter appended.
  *
  * @param foilID - foil id
  * @param fileName - name of the file
  * @param attr - extra attributes
  *
  * @return HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILLINK (String foilID, String fileName, String attr) {
        foilID = evaluateExpression(foilID);
        fileName = evaluateExpression(fileName);
        attr = evaluateExpression(attr);
        String res = "";

        String query = "SELECT TITLE, PID FROM PRESENTATION WHERE PID="+foilID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                res = "<A HREF=\""+fileName+"?PID="+rs.getInt("PID")+"&"+attr+"\">"+rs.getString("TITLE")+"</A><P>";
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"TAGS:WW_FOIL");
        }
        return res;
    }
    
/**
  * Inserts number of foils in the presentation.
  *
  * @param parentID - presentation id
  *
  * @return String eith number of foils
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_NUMBEROFFOILS (String parentID) {
        parentID = evaluateExpression(parentID);
        return getNumberOfFoils (parentID);
    }

/**
  * Inserts HREF link to file with optional attributes.
  *
  * @param filename - name of the file
  * @param attr - optional attributes
  *
  * @return HREF link with parsed contents
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
   	public String WW_LINK (String filename, String attr) {
        filename = evaluateExpression(filename);
        attr = evaluateExpression(attr);
        
        attr = lineToAmp (attr);
        if (attr.equals(""))
    		return ("<A HREF=\""+filename+"\">"+parseChildren()+"</A>");
    	else
	    	return ("<A HREF=\""+filename+"?"+attr+"\">"+parseChildren()+"</A>");
	}
	
/**
  * Inserts link to next foil.
  *
  * @param parentID - presentation id
  * @param foilID - current foil id
  * @param fileName - name of the file for link
  * @param imageName - name (property name) of the image to put into the link
  *
  * @return HREF link with image pointing to next foil
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_NEXT (String parentID, String foilID, String fileName, String imageName) {
        parentID = evaluateExpression (parentID);
        foilID = evaluateExpression (foilID);
        fileName = evaluateExpression (fileName);
        imageName = evaluateExpression (imageName);
        int scUsid = getIntAttrValue (Constants.CurrentUserProperty);
        int usid = unscrambleUser(scUsid);

        String res = "";
        String userID = int2String (usid);
        int fid = string2Int(foilID);
        int pid = string2Int(parentID);
        String imageRetrievalString  = getImageRetrievalString (imageName, foilID, parentID, userID);

        int currentPos = getFoilPosition (fid, pid);
        if (currentPos == 0) return "";
        if (currentPos != getNumberOfFoils (pid)) {
                currentPos++;
                int nextFid = getFoilPid (currentPos, pid);            
           		res = "<A HREF=\""+fileName+"?FID="+nextFid+"&PID="+parentID+"&USID="+scUsid+"\"><IMG SRC=\""+imageRetrievalString+"\" BORDER=0></A>";
        }
        else {
                res = "";
        }
        return res;
    }
    
/**
  * Inserts link to previous foil.
  *
  * @param parentID - presentation id
  * @param foilID - current foil id
  * @param fileName - name of the file for link
  * @param imageName - name (property name) of the image to put into the link
  *
  * @return HREF link with image pointing to previous foil
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_PREV (String parentID, String foilID, String fileName, String imageName) {
        parentID = evaluateExpression(parentID);
        foilID = evaluateExpression(foilID);
        fileName = evaluateExpression(fileName);
        imageName = evaluateExpression(imageName);
        int scUsid = getIntAttrValue (Constants.CurrentUserProperty);
        int usid = unscrambleUser(scUsid);

        String res = "";
        String userID = int2String (usid);
        int fid = string2Int(foilID);
        int pid = string2Int(parentID);
        String imageRetrievalString  = getImageRetrievalString (imageName, foilID, parentID, userID);

        int currentPos = getFoilPosition (fid, pid);
        if (currentPos == 0) return "";
        if (currentPos != 1) {
            currentPos--;
            int prevFid = getFoilPid (currentPos, pid);            
            res = "<A HREF=\""+fileName+"?FID="+prevFid+"&PID="+parentID+"&USID="+scUsid+"\"><IMG SRC=\""+imageRetrievalString+"\" BORDER=0></A>";
        }
        else {
            res = "";
        }
   		return (res);
    }

/**
  * Inserts foil author name
  *
  * @param foilID - current foil id
  *
  * @return String with author name
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_AUTHORNAME (String foilID, String parentID) {
        foilID = evaluateExpression(foilID);
        parentID = evaluateExpression(parentID);
        Statement sqlStatement;
        String res = "";
        boolean found = false;
        String query = "SELECT FIRST_NAME, MIDDLE_NAME, LAST_NAME FROM USERS WHERE USID IN (SELECT USER_UID FROM PRES_AUTHOR WHERE PRES_PID="+foilID+")";
        
        try {
       		sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                found = true;
                String mn = rs.getString("MIDDLE_NAME");
                if (rs.wasNull()) mn ="";
          		res = rs.getString("FIRST_NAME")+" "+mn+" "+rs.getString("LAST_NAME");
          	}
            rs.close(); sqlStatement.close();
            
            if (!found) {
                query = "SELECT FIRST_NAME, MIDDLE_NAME, LAST_NAME FROM USERS WHERE USID IN (SELECT USER_UID FROM PRES_AUTHOR WHERE PRES_PID="+parentID+")";
           		sqlStatement = getConn().createStatement();
              	rs = sqlStatement.executeQuery(query);
                if (rs.next()) {
                    String mn = rs.getString("MIDDLE_NAME");
                    if (rs.wasNull()) mn ="";
              		res = rs.getString("FIRST_NAME")+" "+mn+" "+rs.getString("LAST_NAME");
              	}
              	else res = "";
                rs.close(); sqlStatement.close();
            }
            
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_AUTHOR.SQLException");
        }
       	return res;
    }

/**
  * Inserts foil owner name
  *
  * @param foilID - current foil id
  *
  * @return String with owner name
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_OWNERNAME (String foilID) {
        foilID = evaluateExpression(foilID);
        Statement sqlStatement;
        String res = "";
        String query = "SELECT FIRST_NAME, LAST_NAME FROM USERS WHERE USID = (SELECT OWNER_UID FROM PRESENTATION WHERE PID="+foilID+")";
        try {
       		sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) 
           		res = rs.getString("FIRST_NAME")+" "+rs.getString("LAST_NAME");
           	else 
           	    res = "";
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_OWNER.SQLException");
        }
       	return res;
    }

    
/**
  * Inserts foil position in the presentation
  *
  * @param parentID - presentation id
  * @param foilID - current foil id
  *
  * @return String with foil position
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILNUMBER (String parentID, String foilID) {
        parentID = evaluateExpression(parentID);
        foilID = evaluateExpression(foilID);
     	return getFoilPosition(foilID, parentID);
    }
    
/**
  * Inserts foil title
  *
  * @param foilID - current foil id
  *
  * @return String with foil title
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_TITLE (String foilID) {
        foilID = evaluateExpression(foilID);
        Statement sqlStatement;
        String res = "";

        String query = "SELECT TITLE FROM PRESENTATION WHERE PID = "+foilID;
        try {
       		sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) 
           		res = rs.getString("TITLE");
           	else 
           	    res = "";
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_TITLE.SQLException");
        }
       	return res;
    }
    
/**
  * Inserts foil running title
  *
  * @param foilID - current foil id
  *
  * @return String with foil running title
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_RUNNINGTITLE (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        String query = "SELECT TITLE, RUNNING_TITLE FROM PRESENTATION WHERE PID = "+foilID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) 
       		    res = rs.getString("RUNNING_TITLE");
                if (rs.wasNull()) res = rs.getString("TITLE");
       		else 
       		    res = "";
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_RUNING_TITLE.SQLException");
        }
       	return res;
    }

/**
  * Inserts foil creation date
  *
  * @param foilID - current foil id
  *
  * @return String with creation date
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_CREATIONDATE (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        String query = "SELECT CREATION_DATE FROM PRESENTATION WHERE PID = "+foilID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
       		    Date dt = rs.getDate("CREATION_DATE");
           		res = dt.toString();
           	} 
           	else {
           	    res = "";
           	}
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_CREATIONDATE.SQLException");
        }
       	return res;
    }

/**
  * Inserts foil modification date
  *
  * @param foilID - current foil id
  *
  * @return String with foil modification date
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_MODIFICATIONDATE (String foilID) {
        foilID = evaluateExpression(foilID);
        String res = "";
        String query = "SELECT MODIFICATION_DATE FROM PRESENTATION WHERE PID = "+foilID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
       		    Date dt = rs.getDate("MODIFICATION_DATE");
           		res = dt.toString();
           	}
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"WW_MODIFICATIONDATE.SQLException");
        }
        return res;
    }
    
/**
  * Inserts IMG tag pointing to first foil image
  *
  * @param parentID - presentation id
  * @param foilID - current foil id
  *
  * @return String with IMG tag pointing to foil image
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILIMAGE (String foilID, String parentID) {
        foilID = evaluateExpression (foilID);
        parentID = evaluateExpression (parentID);
        return (showImage (foilID, parentID));
    }
    
    
/**
  * Inserts processed foil HTML text 
  *
  * @param parentID - presentation id
  * @param foilID - current foil id
  *
  * @return String with foil text
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOILTEXT (String foilID) {
        foilID = evaluateExpression (foilID);
        return showText (foilID);
    }
    
    
/**
  * Inserts foil contents depending on mode
  *
  * @param foilID - current foil id
  * @param parentID - presentation id
  * @param mode - presentation mode: IMAGE,TEXT or ASNEEDED-mode is taken from foil attributes.
  *
  * @String with text or IMG tag.
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_FOIL (String foilID, String parentID, String mode) {
        foilID = evaluateExpression (foilID);
        parentID = evaluateExpression (parentID);
        mode = evaluateExpression (mode);

        String res = "";
        if (mode.equals("IMAGE")) {
            res = showImage (foilID, parentID);
        }
        if (mode.equals("TEXT")) {
            res = showText (foilID);
        }
        if (mode.equals("ASNEEDED")) {
            int dbMode = 0;
            String query = "SELECT DISP_MODE FROM PRESENTATION WHERE PID ="+foilID;
            try {
           		Statement sqlStatement = getConn().createStatement();
              	ResultSet rs = sqlStatement.executeQuery(query);
                if (rs.next()) {
                    dbMode = rs.getInt("DISP_MODE");
                }
                rs.close(); sqlStatement.close();
            } catch (SQLException e) {
                ExceptionHandler.handleException(e,"WW_MODIFICATIONDATE.SQLException");
            }
            switch (dbMode) {
                case 1: res = showImage (foilID, parentID); break;
                case 2: res = showImage (foilID, parentID); break;
                case 3: res = showText (foilID); break;
                case 4: res = showText (foilID); break;
                default: res = showImage (foilID, parentID); break;
            }
        }
        return res;
    }
    
/**
  * Inserts abstract image for presentation
  *
  * @param presentationID - presentation id
  *
  * @return String with IMG tag pointing to abstract image
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ABSTRACTIMAGE (String presentationID) {
        presentationID = evaluateExpression(presentationID);
        String res ="";        
        String query = "SELECT ABSTRACT_PID FROM PRESENTATION WHERE PID="+presentationID;        
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                int pid = rs.getInt("ABSTRACT_PID");
                if (rs.wasNull()) pid = getSecondPid(presentationID);
                res = showImage((new String()).valueOf(pid),"");
            } 
            else {
                res = "";
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
                ExceptionHandler.handleException(e,"WW_ABSTRACTIMAGE.SQLException");
        }
        return res;
    }

/**
  * Inserts presentation abstract text
  *
  * @param presentationID - presentation id
  *
  * @return String with processed HTML text of the abstract
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ABSTRACTTEXT (String presentationID) {
        presentationID = evaluateExpression(presentationID);
        String res ="";        
        String query = "SELECT ABSTRACT_PID FROM PRESENTATION WHERE PID="+presentationID;        
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                int pid = rs.getInt("ABSTRACT_PID");
                if (rs.wasNull()) pid = getSecondPid(presentationID);
                res = showText((new String()).valueOf(pid));
            } 
            else {
                res = "";
            }
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
                ExceptionHandler.handleException(e,"WW_ABSTRACTIMAGE.SQLException");
        }
        return res;
    }

    
    
/**
  * Checks if addon exists, if so process the contents
  *
  * @param foilID - current foil id
  * @param parentID - presentation id
  * 
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_SELECTADDON (String foilID, String parentID) {
        foilID = evaluateExpression (foilID);
        parentID = evaluateExpression (parentID);
        String res = "";

        boolean isFoil = dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseAddOnEduType);        
        if (!isFoil) isFoil = dbUtil.checkEduType (getConn(), string2Int(parentID), Constants.DatabaseAddOnEduType);        

        if (isFoil) res+=parseChildren();

        return res;
    }

/**
  * Checks if sound exists, if so process the contents
  *
  * @param foilID - current foil id
  * 
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_SELECTSOUND (String foilID) {
        foilID = evaluateExpression (foilID);
        String res = "";
        if (dbUtil.checkEduType (getConn(), string2Int(foilID), Constants.DatabaseSoundEduType)) res+=parseChildren();
        return res;
    }
    
/**
  * Inserts into <code>name</code> variable display mode for foil
  *
  * @param foilID - current foil id
  * @param name - name of the variable display mode is inserted
  *
  * @return Empty string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_SELECTDISPMODE (String foilID, String name) {
        foilID = evaluateExpression (foilID);
        name = evaluateExpression (name);

        String query = "SELECT DISP_MODE FROM PRESENTATION WHERE PID = "+foilID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                setIntAttrValue(name,rs.getInt("DISP_MODE"));
            } 
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
                ExceptionHandler.handleException(e,"WW_SELECTSOUND.SQLException");
        }
        return "";
    }
    
/**
  * Inserts HREF link to sound
  *
  * @param eID - eudobject id 
  * @param foilID - current foil id
  * @param parentID - presentation id
  *
  * @return String with HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_SOUND (String foilID, String parentID) {
        foilID = evaluateExpression (foilID);
        parentID = evaluateExpression (parentID);
        String res="";
        
        int f = string2Int(foilID);
        int p = string2Int(parentID);
        int u = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));


        String rawHost = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawHost, f, p, u);
        String connID = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawConnectionID, f, p, u);       
        String rawPath = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawSocPath, f, p, u);
        int eID = dbUtil.getPrimaryMediaObjectEid (getConn(), f, p, Constants.DatabaseSoundEduType, 1);
        String src = "http://"+rawHost+"/"+rawPath+"/"+connID+"/"+Constants.EduobjectTableAccess+eID+"/"+Constants.SoundRa+"/sound.ra";
        String image = getImageString ("ww_audio", f, p, u);

        return res = "<BR><A HREF=\""+src+"\"><IMG SRC=\""+image+"\" BORDER=0></A><BR>";
    }

/**
  * Inserts HREF link to addon
  *
  * @param aID - addon id 
  * @param mode - MANUAL or AUTOMATIC
  *
  * @return String with HREF link
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_ADDON (String foilID, String parentID) {
        foilID = evaluateExpression (foilID);
        parentID = evaluateExpression (parentID);
        int i;
        AddonDispComponent ac;
        String res="";
        
        int f = string2Int(foilID);
        int p = string2Int(parentID);
        int u = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        String image = getImageString ("addOnImage_WNT", f, p, u);

        Vector v = dbUtil.readAddonList (getConn(), f, p);
        int number = v.size();
        String acTitle = "";
        for (i = 0; i < number; i++) {
            ac = dbUtil.readAddonDispComponent( getConn(), ((Integer)v.elementAt(i)).intValue() );            
            if (ac.title != null) acTitle = ac.title;
            res += "<BR><A HREF=\""+ac.url+"\"><IMG SRC=\""+image+"\"> "+acTitle+" </A><BR>";
        }

        return res;
    }

/**
  * Inserts inte <code>name</code> variable value of property from database
  *
  * @param name - variable name
  * @param propName - name of the property
  * @param propType - type of the property (IMAGE, COLOR, CONFIGURATION etc.)
  * @param foilID - foil id
  * @param parentID - presentation id
  *
  * @return Empty string 
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    public String WW_DBSET (String name, String propName, String propType, String foilID, String parentID) {
        name = evaluateExpression (name);
        propName = evaluateExpression (propName);
        propType = evaluateExpression (propType);
        foilID = evaluateExpression (foilID);
        parentID = evaluateExpression (parentID);
        

        int f = (new Integer(foilID).intValue());
        int p = (new Integer(parentID).intValue());
        int u = unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));

        
        
        int level, typeP, id;
        if (foilID.equals("")) {
            level = dbProperty.PRESENTATION;
            id = p;
        }
        else 
            if (parentID.equals("")) {
                level = dbProperty.USER;
                id = u;
            }
            else {
                level = dbProperty.FOIL;
                id = f;
            }
        typeP=-1;    
        if (propType.equals("COLOR")) typeP = dbProperty.COLOR;
        if (propType.equals("IMAGE")) typeP = dbProperty.IMAGE; 
        if (propType.equals("FONT")) typeP = dbProperty.FONT;
        if (propType.equals("CONFIGURATION")) typeP = dbProperty.CONFIGURATION;
        if (propType.equals("OVERALL")) typeP = dbProperty.OVERALL;
        if (propType.equals("IMAGE_SIZE")) typeP = dbProperty.IMAGE_SIZE;
        if (typeP==-1) return "";   
        
        dbProperty dbp = new dbProperty (propName, "", id, level, typeP);
        setStringAttrValue (name,(String)dbp.getValueFromDB (u, p, f, getConn()));
        return "";
    }

    
//PRIVATE    
    
 
    
/**
  * Displays text for foil.
  * Private for tags
  *
  * @param foilID - foil id
  *
  * @return String with text
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private String showText (String foilID) {
        String preString = "";
        String res = "";
        int n=0;
        String query = "SELECT DATA_SIZE, DATA FROM EDUOBJECT E, PRES_EDU P WHERE E.EID = P.EDU_EID AND P.PRES_PID = "+foilID+" AND P.EDU_TYPE_ETID = (SELECT ETID FROM EDU_TYPE WHERE TYPE_NAME = '"+Constants.DatabaseTextEduType+"') ORDER BY P.POSITION";
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                InputStream br = rs.getBinaryStream(2);
                int l = rs.getInt(1);
                byte[] b = new byte[l];
                n = br.read(b);
                preString = new String(b);
//                res = processPTag (preString);       //WisdomNT bullets
                res = processPTagTable (preString);    //NPAC like tables
//
            } 
            else {
                res = "";
            }
            rs.close(); sqlStatement.close();
        } catch (Exception e) {
            ExceptionHandler.handleException(e,"showText.Exception");
        }
        
        return res;
    }
 
/**
  * Displays image for foil.
  * Private for tags
  *
  * @param foilID - foil id
  * @param parentID - presentation id
  *
  * @return String with IMG tag
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private String showImage (String foilID, String parentID) {
        int id, level;
        String res = "";

        int f = (new Integer(foilID).intValue());
        int p = (new Integer(parentID).intValue());
        int u =  unscrambleUser(getIntAttrValue (Constants.CurrentUserProperty));
        int eid = -1;
        String rawHost = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawHost, f, p, u);
        String connID = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawConnectionID, f, p, u);       
        String rawPath = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawSocPath, f, p, u);
        
        String src ="";
        String query = "SELECT EDU_EID FROM PRES_EDU WHERE PRES_PID = "+foilID+" AND EDU_TYPE_ETID = (SELECT ETID FROM EDU_TYPE WHERE TYPE_NAME = '"+Constants.DatabaseImageEduType+"') ORDER BY POSITION";
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                eid = rs.getInt("EDU_EID");
                src = "http://"+rawHost+"/"+rawPath+"/"+connID+"/"+Constants.EduobjectTableAccess+eid+"/"+Constants.ImageGif+"/foil.gif";
           	}
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"showImage.SQLException");
        }
        
        if (eid == -1) return "No picture available";        
        
        int imageHor = getHorEduSize (eid);
        int imageVer = getVerEduSize (eid);
        
        String strategyHor = dbPropertyReader.getGeneralProperty( getConn(), Constants.HorImageStyle, f, p, u);
        if (strategyHor.equals("exact")) {
            imageHor = string2Int (dbPropertyReader.getGeneralProperty( getConn(), Constants.HorImageSize, f, p, u));
        }
        else if (strategyHor.equals("minimum")) {
                 int propertyHor = string2Int (dbPropertyReader.getGeneralProperty( getConn(), Constants.HorImageSize, f, p, u));          
                 imageHor = Math.max (imageHor, propertyHor);
             }
             else if (strategyHor.equals("maximum")) {
                     int propertyHor = string2Int (dbPropertyReader.getGeneralProperty( getConn(), Constants.HorImageSize, f, p, u));          
                     imageHor = Math.min (imageHor, propertyHor);
                  }
        
        String strategyVer = dbPropertyReader.getGeneralProperty( getConn(), Constants.VerImageStyle, f, p, u);
        if (strategyVer.equals("exact")) {
            imageVer = string2Int (dbPropertyReader.getGeneralProperty( getConn(), Constants.VerImageSize, f, p, u));
        }
        else if (strategyVer.equals("minimum")) {
                 int propertyVer = string2Int (dbPropertyReader.getGeneralProperty( getConn(), Constants.VerImageSize, f, p, u));          
                 imageVer = Math.max (imageVer, propertyVer);
             }
             else if (strategyVer.equals("maximum")) {
                     int propertyVer = string2Int (dbPropertyReader.getGeneralProperty( getConn(), Constants.VerImageSize, f, p, u));          
                     imageVer = Math.min (imageVer, propertyVer);
                  }
        
  		return ("<IMG SRC=\""+src+"\" WIDTH=\""+imageHor+"\" HEIGHT=\""+imageVer+"\" BORDER=0>");
        

    }

 
    private int getHorEduSize (int eid) {
        int res = -1;
        String query = "SELECT SIZE_X FROM EDUOBJECT WHERE EID = "+eid;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                res = rs.getInt("SIZE_X");    
            } 
            rs.close(); sqlStatement.close();
        } catch (Exception e) {
            ExceptionHandler.handleException(e,"getHorEduSize.Exception");
        }
        return res;
    }


    private int getVerEduSize (int eid) {
        int res = -1;
        String query = "SELECT SIZE_Y FROM EDUOBJECT WHERE EID = "+eid;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
                res = rs.getInt("SIZE_Y");    
            } 
            rs.close(); sqlStatement.close();
        } catch (Exception e) {
            ExceptionHandler.handleException(e,"getVerEduSize.Exception");
        }
        return res;
    }

 
/**
  * Creates a vector with foil ids belonging to presentation
  * Private for tags
  *
  * @param foilID - presentation id
  * @param fidVector - vector for foil ids
  *
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private void fillFoilID (String pID, Vector fidVector) {
        String query = "SELECT CHILD_PID FROM SUBPRESENTATION WHERE PARENT_PID="+pID+" AND HIDDEN=0 ORDER BY POSITION";
        Vector tmpVector = new Vector();
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            while (rs.next()) {
                tmpVector.addElement((new String()).valueOf(rs.getInt("CHILD_PID")));
           	}
            rs.close(); sqlStatement.close();
            int number = tmpVector.size();
            String fid;
            for (int i=0; i<number; i++) {
                fid = (String)tmpVector.elementAt(i);
                if (isFoil (fid)) 
                    fidVector.addElement(fid);
                else 
                    fillFoilID (fid, fidVector);
            }
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"showImage.SQLException");
        }
    }
    
    private String calculateAnnotation (String pid, String position) {
        Vector fids = new Vector();
        Vector pids = new Vector();
        Vector poss = new Vector();
        int nposition = string2Int (position);
        int npid = string2Int (pid);
        
        fillFoilPID (pid, fids, pids, poss);
     
        String parentOfFoil = (String)pids.elementAt(nposition-1);
        String positionThere = (String)poss.elementAt(nposition-1);
        
        if (parentOfFoil.equals(pid)) {
            String st = dbUtil.getAnnotationString (getConn(), npid, nposition);
            if (st != null) return st+"<BR>";
            else return "";
        }
        else {
            return calculateAnnotation (parentOfFoil, positionThere);
        }
    }
    
    private void fillFoilPID (String pID, Vector fidVector, Vector pidVector, Vector posVector) {
        String query = "SELECT CHILD_PID, HIDDEN FROM SUBPRESENTATION WHERE PARENT_PID="+pID+" ORDER BY POSITION";
        Vector tmpVector = new Vector();
        Vector tmpVector2 = new Vector();
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            while (rs.next()) {
                tmpVector.addElement((new String()).valueOf(rs.getInt("CHILD_PID")));
                tmpVector2.addElement((new String()).valueOf(rs.getInt("HIDDEN")));
           	}
            rs.close(); sqlStatement.close();
            int number = tmpVector.size();
            String fid;
            boolean isHid;
            for (int i=0; i<number; i++) {
                isHid = (((String)tmpVector2.elementAt(i)).equals("1"));
                fid = (String)tmpVector.elementAt(i);
                if (isFoil (fid)) {
                    if (!isHid) {
                        fidVector.addElement(fid);
                        pidVector.addElement(pID);
                        posVector.addElement(int2String(i+1));
                    }
                }
                else 
                    fillFoilPID (fid, fidVector, pidVector, posVector);
            }
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"showImage.SQLException");
        }
        
    }
    

/**
  * Checks if presentation is a foil
  * Private for tags
  *
  * @param foilID - foil id
  *
  * @return <code>true</code> if presentation is a foil
  *
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private boolean isFoil(String foilID) {
        boolean result = false;
        
        String sql = "SELECT CHILD_PID FROM SUBPRESENTATION WHERE PARENT_PID = "+foilID;

        try
        {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(sql);
            result = (!rs.next());
            rs.close();
        	rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"isFoil");
            return result;
        }
        return result;
    }
    
/**
  * Gets body from full HTML file
  * Private for tags
  *
  * @param in - input string
  *
  * @return String with body contents
  *
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
   private String getHTMLBody (String in) {
        int bPos = in.indexOf("<BODY>");
        int ePos = in.indexOf("</BODY>");
        if ((bPos == -1) || (ePos == -1)) return in;
        return in.substring(bPos+6, ePos);
   }
 
/**
  * Process the string replacing P tag with tables.
  * Private for tags
  *
  * @param in - input String
  *
  * @return Processed string
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
  
   private String processPTagTable (String in) {
        
        in = getHTMLBody (in);
        String middleString="";
        String begFormat="";
        String endFormat="";
        String tag = "";
        int currentLevel = 0;
        char pTagSign = '+';
        
		int position = in.indexOf ("<P L=");

		while (position != -1) {
			middleString = "";
            int endTag = in.indexOf('>',position);
            tag = in.substring (position, endTag+1); 
			int el = tag.indexOf ("L=");
			int pTagLevel = (new Integer (tag.substring(el+3, el+4))).intValue();
			int pTagTransition = Math.abs(pTagLevel - currentLevel);
            if (pTagLevel >= currentLevel)
    			pTagSign = '+'; 
    		else 
    			pTagSign = '-'; 
    		currentLevel = pTagLevel;	
			if (pTagLevel == 0)	{                   // level = 0
				middleString = "<P>";
			}
			else {
                if (pTagLevel == 1) {               // level = 1
                    if ((pTagTransition == 1)&&(pTagSign=='+'))        // transition +1
                        middleString = "<table  BORDER = 10 CELLSPACING=7 CELLPADDING=7 bgcolor=navajowhite ><tr><td><font size=6 color=black><b>";
                    else                            // transition 0
                        middleString = "</b></td></tr><tr><td><font size=6 color=black><b>";
                } 
                else {                              // level > 1
    				if (pTagTransition == 0) { 
    					middleString = "<LI>";
    				}
    				else {
    					if (pTagSign == '+') {
    						for (int i = 0; i < pTagTransition; i++) middleString = middleString + "<UL>";
    						if (pTagLevel==3) middleString += "</b><i>";
    						middleString = middleString + "<LI>";
    					} 
    					else {
    						for (int i = 0; i < pTagTransition; i++) middleString = middleString + "</UL>";
    						if (pTagLevel==2) middleString += "</i><b>";
    						middleString = middleString + "<LI>";
    					}
    				}
                }
            }		
			
			String preString = in.substring (0, position);
			String postString = in.substring (endTag +1, in.length());
			in = preString + middleString + postString;
	
			position = in.indexOf ("<P L=");			
		}
		in += "</b></td></tr></table>";
        return in;
    }

/**
  * Gets string for IMG tag allowing retrieval of the image from database using
  * get data servlet. Elements are taken from db property.
  * Private for tags
  *
  * @param imageName - property name of the requested image
  * @param foilID - foil id
  * @param parentID - presentation id
  * @param userID - user id
  *
  * @return String with http path
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private String getImageRetrievalString (String imageName, String foilID, String parentID, String userID) { 

        int f = string2Int(parentID);
        int p = string2Int(parentID);
        int u = string2Int(userID);
        String rawHost = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawHost, f, p, u);
        String connID = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawConnectionID, f, p, u);       
        String rawPath = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawSocPath, f, p, u);

        Integer ii = dbPropertyReader.getImageProperty( getConn(),imageName, f, p, u);
        if (ii == null) return imageName;
        int imageIID = ii.intValue();

        return "http://"+rawHost+"/"+rawPath+"/"+connID+"/"+Constants.ImageTableAccess+imageIID+"/"+Constants.ImageGif+"/"+imageName;

    }

 
     private String getImageString (String imageName, int f, int p, int u) { 

        String rawHost = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawHost, f, p, u);
        String connID = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawConnectionID, f, p, u);       
        String rawPath = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawSocPath, f, p, u);
        Integer ii = dbPropertyReader.getImageProperty( getConn(),imageName, f, p, u);
        if (ii == null) return "";
        int imageIID = ii.intValue();

        return "http://"+rawHost+"/"+rawPath+"/"+connID+"/"+Constants.ImageTableAccess+imageIID+"/"+Constants.ImageGif+"/"+imageName;

    }

     
    private String getImageString (String imageName, int p, int u) { 

        String rawHost = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawHost, p, u);
        String connID = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawConnectionID, p, u);       
        String rawPath = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawSocPath, p, u);
        Integer ii = dbPropertyReader.getImageProperty( getConn(),imageName, p, u);
        if (ii == null) return "";
        int imageIID = ii.intValue();

        return "http://"+rawHost+"/"+rawPath+"/"+connID+"/"+Constants.ImageTableAccess+imageIID+"/"+Constants.ImageGif+"/"+imageName;

    }

    private String getImageString (String imageName) { 

        String rawHost = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawHost);
        String connID = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawConnectionID);       
        String rawPath = dbPropertyReader.getGeneralProperty( getConn(), Constants.GetRawSocPath);
        Integer ii = dbPropertyReader.getImageProperty( getConn(),imageName);
        if (ii == null) return "";
        int imageIID = ii.intValue();

        return "http://"+rawHost+"/"+rawPath+"/"+connID+"/"+Constants.ImageTableAccess+imageIID+"/"+Constants.ImageGif+"/"+imageName;

    }
 
/**
  * Replaces "|" sign with "&" sign within attribute strings.
  * <b>Ampersand sign "&" is not allowed in attribute values (TDL parser error)</b>.
  * Private for tags
  *
  * @param in - input string to be processed
  *
  * @return String with "|" replaced
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private String lineToAmp (String in) {
        int pos = in.indexOf('|');
        while (pos!=-1) {
            in = in.substring(0,pos)+"&"+in.substring(pos+1,in.length());
            pos = in.indexOf('|');
        }
        return in;
    }
 
/**
  * Gets id of the second foil in the presentation
  * Private for tags
  *
  * @param presentationID - presentation id
  *
  * @return Integer id of the second foil.
  * 
  * @version 1.0 07/15/98
  * @Author VooVoo
  */
    private int getSecondPid(String presentationID) {
        int res=-1;
        presentationID = evaluateExpression(presentationID);
        String query = "SELECT CHILD_PID FROM SUBPRESENTATION WHERE POSITION = "+Constants.AbstractFoilNumber+" AND PARENT_PID = "+presentationID;
        try {
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
       		    res = rs.getInt("CHILD_PID");
           	} 
           	else {
           	    res = -1;
           	}
            rs.close(); sqlStatement.close();
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"getSecondPid:SQLException");
        }
       	return res;
    }
 
    private String getNumberOfFoils (String pid) {
        Vector v = new Vector ();
        fillFoilID (pid, v);
        return int2String(v.size());
    }

    private int getNumberOfFoils (int pid) {
        Vector v = new Vector ();
        fillFoilID (int2String(pid), v);
        return v.size();
    }

    
    private String getFoilPosition (String fid, String pid) {
        Vector v = new Vector();
        fillFoilID (pid, v);
        return int2String(v.indexOf(fid)+1);       
    }

    private int getFoilPosition (int fid, int pid) {
        Vector v = new Vector();
        String spid = (new String()).valueOf(pid);
        String sfid = (new String()).valueOf(fid);
        fillFoilID (spid, v);
        return v.indexOf(sfid)+1;       
    }

    private String getFoilPid (int position, String pid) {
        Vector v = new Vector();
        fillFoilID (pid, v);
        return (String)v.elementAt(position-1);       
    }
    
    private int getFoilPid (int position, int pid) {
        Vector v = new Vector();
        String spid = (new String()).valueOf(pid);
        fillFoilID (spid, v);
        return string2Int((String)v.elementAt(position-1));       
    }
    
    
    private String int2String (int i) {
        return (new String()).valueOf(i);
    }
    
    private int string2Int (String s) {
        try {
            return Integer.parseInt(s);      
        } catch (NumberFormatException n) {
            n.printStackTrace();
            return -1;
        }
    }
    
    private boolean userHasRights(int wid, int usid) {

        boolean res = false;
        try {
            String query = "SELECT OWNER_UID FROM FOILWORLD WHERE WID="+wid;
       		Statement sqlStatement = getConn().createStatement();
          	ResultSet rs = sqlStatement.executeQuery(query);
            if (rs.next()) {
       		    if (usid == rs.getInt("OWNER_UID")) res = true;  //is owner
           	} 
            rs.close(); sqlStatement.close();
            if (!res) {
                query = "SELECT ACCESS_MODE FROM ACCESS_TO_FOILWORLD WHERE USER_UID = "+usid+" AND FOILWORLD_WID ="+wid;
           		sqlStatement = getConn().createStatement();
              	rs = sqlStatement.executeQuery(query);
                if (rs.next()) {
                    String tmp = rs.getString("ACCESS_MODE");
                    if (tmp.indexOf(Constants.AccessModeReadRight) != -1) res = true; 
               	} 
                rs.close(); sqlStatement.close();
                
            }
        } catch (SQLException e) {
            ExceptionHandler.handleException(e,"getSecondPid:SQLException");
        }
        return res;
    }
    
    
    
    
 
    
    
}