
import java.io.*;
import java.util.*;

public class XMLDecodeReader extends FilterReader {

    int currentChar;

    public XMLDecodeReader(Reader r)
    {
        super(r);
        try {
            currentChar = super.read();
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }

    public int read() throws IOException
    {
        int res = currentChar;

        try {
            int nextChar = super.read();

            char cc = (char)currentChar;
            char nc = (char)nextChar;

            currentChar = nextChar;

            if ((cc=='^')&&(nc=='^'))   { res = (int)'<';  currentChar = super.read(); }
            if ((cc=='\\')&&(nc=='^'))  { res = (int)'^';  currentChar = super.read(); }
            if ((cc=='\\')&&(nc=='\\')) { res = (int)'\\'; currentChar = super.read(); }
        }
        catch (IOException e){
            currentChar = -1;
        }

        return (res);
    }


    public int read(char b[], int off, int len) throws IOException
    {
	if (len <= 0) {
	    return 0;
	}

	int c = read();
	if (c == -1) {
	    return -1;
	}
	b[off] = (char)c;

	int i = 1;
	try {
	    for (; i < len ; i++) {
		c = read();
		if (c == -1) {
		    break;
		}
		if (b != null) {
		    b[off + i] = (char)c;
		}
	    }
	} catch (IOException ee) {
	}
	return i;
    }
}
