/* $Id: Enhancer.java,v 1.4 1999/03/02 20:50:15 remek Exp $
   Revision:   $Revision: 1.4 $
   Updated:    $Date: 1999/03/02 20:50:15 $
   Updated by: $Author: remek $
   Copyright 1999 NPAC, Syracuse University
*/


import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class Enhancer extends HttpServlet 
{
    public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
    {
	try{
	    
	URL targetURL;
	String temp = req.getParameter("url");
	if(temp==null){
	    reportError("url parameter not specified!", res);
	    return;
	}
	
	try{
	    targetURL = new URL(req.getParameter("url"));
	}
	catch (MalformedURLException e){
	    reportError("Malformed URL: " + e.toString(), res);
	    return;
	}
	
	HttpURLConnection connectionURL;
	try{
	    connectionURL = (HttpURLConnection)targetURL.openConnection();
	}
	catch(IOException e){
	    
	    reportError(e.toString(), res);
	    return;
	}
	
	String typeURL = connectionURL.getContentType();
	if(typeURL==null){
	    reportError("Could not open the connection to specified URL!",
			res);
	    return;
	}

	res.setContentType(typeURL);

	BufferedReader input;
	InputStream tempis = connectionURL.getInputStream();
	if(tempis==null){
	    reportError("Empty input stream!", res);
	    return;
	}
	    
	input = new BufferedReader(new InputStreamReader(tempis));

	if(typeURL.substring(0, 4).toUpperCase().compareTo("TEXT") != 0){
	    //unknown type content
	    OutputStreamWriter out;
	    out = new OutputStreamWriter(res.getOutputStream());
	    int c;
	    
	    while (-1 != ((c = input.read()))) 
		out.write(c);
	    
	    out.close();
	} else {
	    //text/html
	    
	    PrintWriter out;
	    out = res.getWriter();
	    
	    String str = null;
	    String wholeDoc = "";
	
	    try{
		while (null != ((str = input.readLine()))) 
		    wholeDoc = wholeDoc +  str + "\n";
	    }
	    catch(Exception e){
		reportError("Server closed connection.  URL not found?", res);
		return;
	    }
	    

		
	    String newDoc = processHead(wholeDoc, req);
	    wholeDoc = processLinks(newDoc);
	    
	    out.println(wholeDoc);
	    
	}
	input.close ();
	
	}
	catch(Exception e){
	    reportError("unexpected exception " + e.toString(), res);
	}
	
    }

    public String processHead(String page, HttpServletRequest req)
    {
	String result = new String(page);

	String baseURL = new String(req.getParameter("url"));
	String trailingSlash = "/";

	if(baseURL.substring(baseURL.length()-4).toUpperCase().compareTo("HTML")==0 ||
	   baseURL.substring(baseURL.length()-3).toUpperCase().compareTo("HTM")==0)
	    trailingSlash = "";
	
	try{
	    int headStart = page.indexOf("<HEAD>");
	    if(headStart==-1) headStart = page.indexOf("<head>");
	
	    if(headStart!=-1) {
		result = page.substring(0, headStart + 6) +
		    "<BASE href=" + baseURL + trailingSlash + ">" +
		    page.substring(headStart + 6);
	    }
	}
	catch(Exception e){
	    return "Exception int processHead: " + e.toString();
	}
	return result;
    }

    public String processLinks(String page)
    {
	StringBuffer result = new StringBuffer();
	try{
	    StringTokenizer linkST = new StringTokenizer(page, "<");
	    while(linkST.hasMoreTokens()){
		String potentialA = linkST.nextToken();
		if(potentialA.length()==1 &&
		   potentialA.substring(0,1).toUpperCase().compareTo("A")==0)
		    result = result.append("<a onClick=\"this.href='http://winnie:8080/servlets/Enhancer?url='+this.href;\" ");
		else
		    if(potentialA.substring(0,2).toUpperCase().compareTo("A ")==0)
			result = result.append("<a onClick=\"this.href='http://winnie:8080/servlets/Enhancer?url='+this.href;\" ").append(potentialA.substring(2));
		    else
			result = result.append("<" + potentialA);
	    }
	}
	catch(Exception e){
	    return "Exception int processLinks: " + e.toString();
	}

	return result.toString();
    }
    

    public void reportError(String message, HttpServletResponse res)
	throws IOException 
    {
	res.setContentType("text/html");
	PrintWriter out;
	out = res.getWriter();
	out.println(message);
    }
}

- -- 
Remek Trzaska                  http://www.npac.syr.edu/users/remek
Research Scientist
Northeast Parallel Architectures Center at Syracuse University, NY

-----BEGIN PGP SIGNATURE-----
Version: PGPfreeware 5.0i for non-commercial use
Comment: Processed by Mailcrypt 3.5.2, an Emacs/PGP interface
Charset: noconv

iQBVAwUBNuQ/G8IrSVSa9Oq9AQFo3gIAi2oHQOXsT4fvmlb+ose/isyhRVgDne+u
HMJlnIniBiNQwKmHXBlcj8As7TxZsk3LQqC80YynudRwtHq05SPa1w==
=e3tu
-----END PGP SIGNATURE-----


